"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EvaluationPlansImplementation = void 0;
var mssql_service_1 = require("../db/mssql.service");
var log4js = require("log4js");
var logger = log4js.getLogger('Task');
var EvaluationPlansImplementation = (function () {
    function EvaluationPlansImplementation() {
    }
    EvaluationPlansImplementation.prototype.Execute = function (currentDate) {
        var promiseArray = [];
        var evaluationPlansExpired = [];
        return mssql_service_1.MSSql.GetEvaluationPlansExpired(currentDate)
            .then(function (result) {
            result.forEach(function (planExpired) {
                var vcc = planExpired.vcc, id = planExpired.id, idInteraction = planExpired.idInteraction, idAuditor = planExpired.idAuditor, lastModifiedByUserId = planExpired.lastModifiedByUserId;
                evaluationPlansExpired.push({ vcc: vcc, id: id });
                promiseArray.push(mssql_service_1.MSSql.SaveEvaluationStatus(vcc, id, idInteraction, idAuditor, false, true, lastModifiedByUserId));
            });
            return Promise.all(promiseArray);
        })
            .then(function (_) {
            promiseArray = [];
            evaluationPlansExpired = evaluationPlansExpired.filter(function (obj, index) { return evaluationPlansExpired.findIndex(function (item) { return item.id === obj.id; }) === index; });
            evaluationPlansExpired.forEach(function (planExpired) {
                var vcc = planExpired.vcc, id = planExpired.id;
                promiseArray.push(mssql_service_1.MSSql.SaveEvaluationPlanCompleted(vcc, id));
            });
            return Promise.all(promiseArray);
        })
            .catch(function (err) {
            var errorMessage = typeof err === 'string' ? err : (err.message || err.description);
            logger.error('[EvaluationPlansImplementation::Execute] executionCode:', currentDate, 'getting errorMessage:', errorMessage);
            return Promise.resolve(false);
        });
        ;
    };
    return EvaluationPlansImplementation;
}());
exports.EvaluationPlansImplementation = EvaluationPlansImplementation;
